Index: trunk/drmaa_utils/drmaa_utils/thread.c
===================================================================
--- trunk/drmaa_utils/drmaa_utils/thread.c	(revision 1)
+++ trunk/drmaa_utils/drmaa_utils/thread.c	(revision 1)
@@ -0,0 +1,418 @@
+/* $Id: thread.c 2 2009-10-12 09:51:22Z mamonski $ */
+/*
+ *  FedStage DRMAA utilities library
+ *  Copyright (C) 2006-2008  FedStage Systems
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/**
+ * @file thread.c
+ * Implementation of recursive mutexes for systems without native support
+ * for it.
+ */
+
+
+#ifdef HAVE_CONFIG_H
+#	include <config.h>
+#endif
+
+#include <drmaa_utils/thread.h>
+#include <drmaa_utils/common.h>
+#include <errno.h>
+#include <unistd.h>
+
+#ifdef HAVE_GETTID
+#include <sys/types.h>
+#include <sys/syscall.h>
+pid_t gettid(void)
+{
+	return (pid_t)syscall( __NR_gettid );
+}
+#endif
+
+#ifndef lint
+static char rcsid[]
+#	ifdef __GNUC__
+		__attribute__ ((unused))
+#	endif
+	= "$Id: thread.c 2 2009-10-12 09:51:22Z mamonski $";
+#endif
+
+
+void
+fsd_thread_create( fsd_thread_t *thread, void* (*func)(void*), void *arg )
+{
+	int errno_ = 0;
+	errno_ = pthread_create( thread, NULL, func, arg );
+	if( errno_ )
+		fsd_exc_raise_sys( errno_ );
+}
+
+void
+fsd_thread_join( fsd_thread_t th, void **thread_return )
+{
+	int errno_ = 0;
+	errno_ = pthread_join( th, thread_return );
+	if( errno_ )
+		fsd_exc_raise_sys( errno_ );
+}
+
+void
+fsd_thread_detach( fsd_thread_t th )
+{
+	int errno_ = 0;
+	errno_ = pthread_detach( th );
+	if( errno_ )
+		fsd_exc_raise_sys( errno_ );
+}
+
+
+#if HAVE_RECURSIVE_MUTEXES
+
+void
+fsd_mutex_init( fsd_mutex_t *mutex )
+{
+	int errno_ = 0;
+	pthread_mutexattr_t attr;
+	do {
+		errno_ = pthread_mutexattr_init( &attr );
+		if( errno_ )  break;
+		errno_ = pthread_mutexattr_settype( &attr, PTHREAD_MUTEX_RECURSIVE_NP );
+		if( errno_ )  break;
+		errno_ = pthread_mutex_init( mutex, &attr );
+		if( errno_ )  break;
+		errno_ = pthread_mutexattr_destroy( &attr );
+	} while( false );
+	if( errno_ )
+		fsd_exc_raise_sys( errno_ );
+}
+
+void
+fsd_mutex_destroy( fsd_mutex_t *mutex )
+{
+	int errno_ = 0;
+	errno_ = pthread_mutex_destroy( mutex );
+	if( errno_ )
+		fsd_exc_raise_sys( errno_ );
+}
+
+bool
+fsd_mutex_lock( fsd_mutex_t *mutex )
+{
+	int errno_ = 0;
+	errno_ = pthread_mutex_lock( mutex );
+	if( errno_ )
+		fsd_exc_raise_sys( errno_ );
+	return true;
+}
+
+bool
+fsd_mutex_unlock( fsd_mutex_t *mutex )
+{
+	int errno_ = 0;
+	errno_ = pthread_mutex_unlock( mutex );
+	if( errno_ )
+		fsd_exc_raise_sys( errno_ );
+	return false;
+}
+
+bool
+fsd_mutex_trylock( fsd_mutex_t *mutex )
+{
+	int errno_ = 0;
+	errno_ = pthread_mutex_trylock( mutex );
+	switch( errno_ )
+	 {
+		case 0:
+			return true;
+		case EBUSY:
+			return false;
+		default:
+			fsd_exc_raise_sys( errno_ );
+	 }
+}
+
+int
+fsd_mutex_unlock_times( fsd_mutex_t *mutex )
+{
+	int count = 0;
+	int errno_ = 0;
+	while( errno_ == 0 )
+	 {
+		errno_ = pthread_mutex_unlock( mutex );
+		if( !errno_ )
+			count++;
+	 }
+	if( errno_ != EPERM  ||  count == 0 )
+		fsd_exc_raise_sys( errno_ );
+	return count;
+}
+
+void
+fsd_cond_init( fsd_cond_t *cond )
+{
+	int errno_ = 0;
+	errno_ = pthread_cond_init( cond, NULL );
+	if( errno_ )
+		fsd_exc_raise_sys( errno_ );
+}
+
+void
+fsd_cond_destroy( fsd_cond_t *cond )
+{
+	int errno_ = 0;
+	errno_ = pthread_cond_destroy( cond );
+	if( errno_ )
+		fsd_exc_raise_sys( errno_ );
+}
+
+void
+fsd_cond_signal( fsd_cond_t *cond )
+{
+	int errno_ = 0;
+	errno_ = pthread_cond_signal( cond );
+	if( errno_ )
+		fsd_exc_raise_sys( errno_ );
+}
+
+void
+fsd_cond_broadcast( fsd_cond_t *cond )
+{
+	int errno_ = 0;
+	errno_ = pthread_cond_broadcast( cond );
+	if( errno_ )
+		fsd_exc_raise_sys( errno_ );
+}
+
+void
+fsd_cond_wait( fsd_cond_t *cond, fsd_mutex_t *mutex )
+{
+	int errno_ = 0;
+	errno_ = pthread_cond_wait( cond, mutex );
+	if( errno_ )
+		fsd_exc_raise_sys( errno_ );
+}
+
+bool
+fsd_cond_timedwait( fsd_cond_t *cond, fsd_mutex_t *mutex,
+		const struct timespec *abstime )
+{
+	int errno_ = 0;
+	errno_ = pthread_cond_timedwait( cond, mutex, abstime );
+	switch( errno_ )
+	 {
+		case 0:
+			return true;
+		case ETIMEDOUT:
+			return false;
+		default:
+			fsd_exc_raise_sys( errno_ );
+	 }
+}
+
+#else /* ! HAVE_RECURSIVE_MUTEXES */
+
+void
+fsd_mutex_init( fsd_mutex_t *mutex )
+{
+	int errno_ = 0;
+	mutex->owner = (pthread_t)-1;
+	mutex->acquired = 0;
+	errno_ = pthread_mutex_init( &mutex->mutex, NULL );
+	if( errno_ )
+		fsd_exc_raise_sys( errno_ );
+}
+
+void
+fsd_mutex_destroy( fsd_mutex_t *mutex )
+{
+	int errno_ = 0;
+	errno_ = pthread_mutex_destroy( &mutex->mutex );
+	if( errno_ )
+		fsd_exc_raise_sys( errno_ );
+}
+
+bool
+fsd_mutex_lock( fsd_mutex_t *mutex )
+{
+	/* Note: The order of checks is significant. */
+	if( mutex->acquired  &&  pthread_equal( mutex->owner, pthread_self() ) )
+		mutex->acquired ++;
+	else
+	 {
+		int errno_ = 0;
+		errno_ = pthread_mutex_lock( &mutex->mutex );
+		if( errno_ == 0 )
+		 {
+			mutex->owner    = pthread_self();
+			mutex->acquired = 1;
+		 }
+		else
+			fsd_exc_raise_sys( errno_ );
+	 }
+	return true;
+}
+
+bool
+fsd_mutex_unlock( fsd_mutex_t *mutex )
+{
+	fsd_assert( mutex->acquired
+			&&  pthread_equal( mutex->owner, pthread_self() ) );
+	if( -- (mutex->acquired) == 0 )
+	 {
+		int errno_ = 0;
+		errno_ = pthread_mutex_unlock( &mutex->mutex );
+		if( errno_ )
+			fsd_exc_raise_sys( errno_ );
+	 }
+	return false;
+}
+
+bool
+fsd_mutex_trylock( fsd_mutex_t *mutex )
+{
+	if( mutex->acquired  &&  pthread_equal( mutex->owner, pthread_self() ) )
+	 {
+		mutex->acquired ++;
+		return true;
+	 }
+	else
+	 {
+		int errno_ = 0;
+		errno_ = pthread_mutex_trylock( &mutex->mutex );
+		switch( errno_ )
+		 {
+			case 0:
+				mutex->owner    = pthread_self();
+				mutex->acquired = 1;
+				return true;
+			case ETIMEDOUT:
+				return false;
+			default:
+				fsd_exc_raise_sys( errno_ );
+		 }
+	 }
+}
+
+int
+fsd_mutex_unlock_times( fsd_mutex_t *mutex )
+{
+	int errno_ = 0;
+	int count = 0;
+	fsd_assert( mutex->acquired
+			&&  pthread_equal( mutex->owner, pthread_self() ) );
+	count = mutex->acquired;
+	mutex->acquired = 0;
+	errno_ = pthread_mutex_unlock( &mutex->mutex );
+	if( errno_ )
+		fsd_exc_raise_sys( errno_ );
+	return count;
+}
+
+void
+fsd_cond_init( fsd_cond_t *cond )
+{
+	int errno_ = 0;
+	errno_ = pthread_cond_init( cond, NULL );
+	if( errno_ )
+		fsd_exc_raise_sys( errno_ );
+}
+
+void
+fsd_cond_destroy( fsd_cond_t *cond )
+{
+	int errno_ = 0;
+	errno_ = pthread_cond_destroy( cond );
+	if( errno_ )
+		fsd_exc_raise_sys( errno_ );
+}
+
+void
+fsd_cond_signal( fsd_cond_t *cond )
+{
+	int errno_ = 0;
+	errno_ = pthread_cond_signal( cond );
+	if( errno_ )
+		fsd_exc_raise_sys( errno_ );
+}
+
+void
+fsd_cond_broadcast( fsd_cond_t *cond )
+{
+	int errno_ = 0;
+	errno_ = pthread_cond_broadcast( cond );
+	if( errno_ )
+		fsd_exc_raise_sys( errno_ );
+}
+
+void
+fsd_cond_wait( fsd_cond_t *cond, fsd_mutex_t *mutex )
+{
+	int errno_ = 0;
+	int acquired_save = mutex->acquired;
+	fsd_assert( mutex->acquired
+			&&  pthread_equal( mutex->owner, pthread_self() ) );
+	errno_ = pthread_cond_wait( cond, &mutex->mutex );
+	if( errno_ == 0 )
+	 {
+		mutex->owner = pthread_self();
+		mutex->acquired = acquired_save;
+	 }
+	else
+		fsd_exc_raise_sys( errno_ );
+}
+
+bool
+fsd_cond_timedwait( fsd_cond_t *cond, fsd_mutex_t *mutex,
+		const struct timespec *abstime )
+{
+	int errno_ = 0;
+	int acquired_save = mutex->acquired;
+	fsd_assert( mutex->acquired
+			&&  pthread_equal( mutex->owner, pthread_self() ) );
+	errno_ = pthread_cond_timedwait( cond, &mutex->mutex, abstime );
+	switch( errno_ )
+	 {
+		case 0:
+			mutex->owner = pthread_self();
+			mutex->acquired = acquired_save;
+			return true;
+		case ETIMEDOUT:
+			mutex->owner = pthread_self();
+			mutex->acquired = acquired_save;
+			return false;
+		default:
+			fsd_exc_raise_sys( errno_ );
+	 }
+}
+
+#endif /* ! HAVE_RECURSIVE_MUTEXES */
+
+
+
+int
+fsd_thread_id(void)
+{
+#if HAVE_GETTID
+	/*
+	 * On Linux 2.6 (with NPTL) getpid() returns
+	 * same value for all threads in single process.
+	 */
+	return (int)gettid();
+#else
+	return (int)getpid();
+#endif
+}
+
Index: trunk/drmaa_utils/drmaa_utils/datetime_tab.y
===================================================================
--- trunk/drmaa_utils/drmaa_utils/datetime_tab.y	(revision 1)
+++ trunk/drmaa_utils/drmaa_utils/datetime_tab.y	(revision 1)
@@ -0,0 +1,110 @@
+/* $Id: datetime_tab.y 1450 2008-10-01 22:22:59Z lukasz $ */
+/*
+ *  FedStage DRMAA utilities library
+ *  Copyright (C) 2006-2008  FedStage Systems
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+%{
+#ifdef HAVE_CONFIG_H
+#	include <config.h>
+#endif
+#include <drmaa_utils/datetime_impl.h>
+%}
+
+/* those are Bison extensions */
+%glr-parser
+%pure-parser
+%name-prefix="fsd_dt_"
+%parse-param { fsd_dt_parser_t *parser }
+%parse-param { fsd_dt_lexer_t *lexer }
+%lex-param { fsd_dt_lexer_t *lexer }
+
+%union {
+	fsd_datetime_t datetime;
+	int              integer;
+}
+
+%type<datetime> datetime date time timezone
+%type<integer>  sign
+%token<integer> NUM
+%token LEXER_ERROR
+
+%%
+
+start : datetime { parser->result = $1; }
+	;
+
+datetime
+	: time timezone {
+		$$.mask = $1.mask | $2.mask;
+		$$.year = 0;  $$.month = 0;  $$.day = 0;
+		$$.hour   = $1.hour;
+		$$.minute = $1.minute;
+		$$.second = $1.second;
+		$$.tz_delta = $2.tz_delta;
+	}
+	| date opt_sep time timezone {
+		$$.mask = $1.mask | $3.mask | $4.mask;
+		$$.year   = $1.year;
+		$$.month  = $1.month;
+		$$.day    = $1.day;
+		$$.hour   = $3.hour;
+		$$.minute = $3.minute;
+		$$.second = $3.second;
+		$$.tz_delta = $4.tz_delta;
+	}
+	;
+
+opt_sep
+	:
+	| 'T'
+	;
+
+date
+	: NUM '-' NUM '-' NUM  { $$.year=$1;  $$.month=$3;  $$.day=$5;
+	                         $$.mask=FSD_DT_YEAR|FSD_DT_MONTH|FSD_DT_DAY; }
+	| NUM '-' NUM          { $$.year=0;   $$.month=$1;  $$.day=$3;
+	                         $$.mask=FSD_DT_MONTH|FSD_DT_DAY; }
+	| NUM '/' NUM '/' NUM  { $$.year=$1;  $$.month=$3;  $$.day=$5;
+	                         $$.mask=FSD_DT_YEAR|FSD_DT_MONTH|FSD_DT_DAY; }
+	| NUM '/' NUM          { $$.year=0;   $$.month=$1;  $$.day=$3;
+	                         $$.mask=FSD_DT_MONTH|FSD_DT_DAY; }
+	| NUM                  { $$.year=0;   $$.month=0;   $$.day=$1;
+	                         $$.mask=FSD_DT_DAY; }
+	;
+
+
+time
+	: NUM ':' NUM          { $$.hour=$1;  $$.minute=$3;  $$.second=0;
+	                         $$.mask=FSD_DT_HOUR|FSD_DT_MINUTE; }
+	| NUM ':' NUM ':' NUM  { $$.hour=$1;  $$.minute=$3;  $$.second=$5;
+	                         $$.mask=FSD_DT_HOUR|FSD_DT_MINUTE|FSD_DT_SECOND; }
+	;
+
+timezone
+	:                   { $$.tz_delta=0;  $$.mask=0; }
+	| sign NUM          { $$.tz_delta=$1*3600*$2;  $$.mask=FSD_DT_TZ_DELTA; }
+	| sign NUM ':' NUM  { $$.tz_delta=$1*60*(60*$2+$4);
+	                      $$.mask=FSD_DT_TZ_DELTA; }
+	| 'Z'               { $$.tz_delta=0;  $$.mask=FSD_DT_TZ_DELTA; }
+	;
+
+sign
+	:      { $$ = +1; }
+	| '+'  { $$ = +1; }
+	| '-'  { $$ = -1; }
+	;
+
Index: trunk/drmaa_utils/drmaa_utils/fsd_util.c
===================================================================
--- trunk/drmaa_utils/drmaa_utils/fsd_util.c	(revision 1)
+++ trunk/drmaa_utils/drmaa_utils/fsd_util.c	(revision 1)
@@ -0,0 +1,644 @@
+/* $Id: fsd_util.c 185 2010-05-13 17:10:00Z mmatloka $ */
+/*
+ *  FedStage DRMAA utilities library
+ *  Copyright (C) 2006-2008  FedStage Systems
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifdef HAVE_CONFIG_H
+#	include <config.h>
+#endif
+
+#include <fcntl.h>
+#include <sys/stat.h>
+#include <sys/time.h>
+#include <unistd.h>
+
+#include <ctype.h>
+#include <errno.h>
+#include <limits.h>
+#include <signal.h>
+#include <stdlib.h>
+#include <string.h>
+#include <stdio.h>
+
+#include <drmaa_utils/common.h>
+#include <drmaa_utils/util.h>
+
+#ifndef lint
+static char rcsid[]
+#	ifdef __GNUC__
+		__attribute__ ((unused))
+#	endif
+	= "$Id: fsd_util.c 185 2010-05-13 17:10:00Z mmatloka $";
+#endif
+
+
+static char *
+fsd_expand_printf_ph( const char *fmt );
+
+
+void
+fsd_free_vector( char **vector )
+{
+	char **i;
+	if( vector == NULL )
+		return;
+	for( i = vector;  *i != NULL;  i++ )
+		fsd_free( *i );
+	fsd_free( vector );
+}
+
+
+char **
+fsd_copy_vector( const char *const * vector )
+{
+	unsigned n_items, i;
+	char** volatile buf = NULL;
+	char** volatile result = NULL;
+
+	TRY
+	 {
+		if( vector )
+			for( n_items = 0;  vector[ n_items ] != NULL;  n_items++ ) {}
+		else
+			n_items = 0;
+
+		fsd_calloc( buf, n_items+1, char* );
+		for( i = 0;  i < n_items;  i++ )
+			buf[i] = fsd_strdup( vector[i] );
+	 }
+	ELSE
+	 { result = buf;  buf = NULL; }
+	FINALLY
+	 { fsd_free_vector( buf ); }
+	END_TRY
+
+	return result;
+}
+
+
+char *
+fsd_replace( char *str, const char *placeholder, const char *value )
+{
+	size_t ph_len, v_len;
+	char *found = NULL;
+	char* volatile s = str;
+
+	if( str == NULL )
+		fsd_exc_raise_code( FSD_ERRNO_INTERNAL_ERROR );
+
+	ph_len = strlen( placeholder );
+	v_len  = strlen( value );
+
+	do {
+		size_t s_len;
+		s_len = strlen( s );
+		found = strstr( s, placeholder );
+		if( found )
+		 {
+			char* volatile result;
+			size_t pos = found - s;
+			TRY
+			 {
+				fsd_calloc( result, s_len - ph_len + v_len + 1, char );
+				memcpy( result, s, pos );
+				memcpy( result+pos, value, v_len );
+				memcpy( result+pos+v_len, s+pos+ph_len, s_len-pos-ph_len );
+				result[ s_len-ph_len+v_len ] = 0;
+			 }
+			FINALLY
+			 {
+				fsd_free( s );
+				s = result;
+			 }
+			END_TRY
+		 }
+	} while( found );
+
+	return s;
+}
+
+
+char *
+fsd_explode( const char *const *vector, char glue, int n )
+{
+	char* volatile result = NULL;
+	char* volatile buf = NULL;
+	char *s;
+	const char *const *i;
+	unsigned idx, max=(unsigned)n;
+	size_t size =0;
+
+	TRY
+	 {
+		for( i = vector, idx = 0;  idx < max && *i != NULL;  i++, idx++ )
+		 {
+			if( i != vector )
+				size++;
+			size += strlen(*i);
+		 }
+
+		fsd_calloc( buf, size+1, char );
+		s = buf;
+		for( i = vector, idx = 0;  idx < max && *i != NULL;  i++, idx++ )
+		 {
+			if( i != vector )
+				*s++ = glue;
+			strcpy( s, *i );
+			s += strlen( *i );
+		 }
+	 }
+	ELSE
+	 { result = buf;  buf = NULL; }
+	FINALLY
+	 { fsd_free( buf ); }
+	END_TRY
+
+	return result;
+}
+
+
+char *
+fsd_strdup( const char *s )
+{
+	char *result;
+	if( s == NULL )
+		return NULL;
+	result = strdup( s );
+	if( result == NULL )
+		fsd_exc_raise_sys( ENOMEM );
+	return result;
+}
+
+
+char *
+fsd_strndup( const char *s, size_t n )
+{
+	char *result;
+	if( s == NULL )
+		return NULL;
+	result = strndup( s, n );
+	if( result == NULL )
+		fsd_exc_raise_sys( ENOMEM );
+	return result;
+}
+
+
+int
+fsd_atoi( const char *string )
+{
+	const char *s = string;
+	int sign = +1;
+	int v = 0;
+
+	while( isspace(*(const unsigned char*)s) )
+		s++;
+	switch( *s )
+	 {
+		case '+':  sign = +1;  s++;  break;
+		case '-':  sign = -1;  s++;  break;
+		default:  break;
+	 }
+	while( isspace(*(const unsigned char*)s) )
+		s++;
+	if( '0' <= *s  &&  *s <= '9' )
+	 {
+		while( '0' <= *s  &&  *s <= '9' )
+		 {
+			if( v > INT_MAX/10 )
+				goto range_error;
+			v *= 10;
+			v += *s++ - '0';
+			if( v < 0 )
+				goto range_error;
+		 }
+	 }
+	else
+		goto nan_error;
+
+	while( isspace(*(const unsigned char*)s) )
+		s++;
+	if( *s != '\0' )
+		goto nan_error;
+
+	return sign * v;
+
+range_error:
+	fsd_exc_raise_fmt( FSD_ERRNO_INVALID_ARGUMENT,
+			"value out of range: %s", string );
+	return 0;
+
+nan_error:
+		fsd_exc_raise_fmt( FSD_ERRNO_INVALID_ARGUMENT,
+				"not an number: %s", string );
+	return 0;
+}
+
+
+void
+fsd_str_append(
+		bool *truncated,
+		char **p, char *end,
+		const char *fmt, ...
+		)
+{
+	va_list args;
+	va_start( args, fmt );
+	*p += fsd_vsnprintf( truncated, *p, end-*p, fmt, args );
+	va_end( args );
+}
+
+
+size_t
+fsd_snprintf(
+		bool *truncated,
+		char *str, size_t size,
+		const char *fmt, ...
+		)
+{
+	va_list args;
+	size_t result;
+	va_start( args, fmt );
+	result = fsd_vsnprintf( truncated, str, size, fmt, args );
+	va_end( args );
+	return result;
+}
+
+
+size_t
+fsd_vsnprintf(
+		bool *truncated,
+		char *str, size_t size,
+		const char *fmt, va_list args
+		)
+{
+	int n;
+	char *fmt_buf = NULL;
+	fmt_buf = fsd_expand_printf_ph( fmt );
+	if( fmt_buf )
+		fmt = fmt_buf;
+	n = vsnprintf( str, size, fmt, args );
+	if( fmt_buf )
+		fsd_free( fmt_buf );
+	if( 0 <= n  &&  (size_t)n < size )
+	 {}
+	else
+	 {
+		str[size-1] = '\0';
+		*truncated = true;
+	 }
+	return n;
+}
+
+
+char *
+fsd_asprintf( const char *fmt, ... )
+{
+	va_list args;
+	char *result = NULL;
+	va_start( args, fmt );
+	result = fsd_vasprintf( fmt, args );
+	va_end( args );
+	return result;
+}
+
+
+char *
+fsd_vasprintf( const char *fmt, va_list args )
+{
+	char *result = NULL;
+	char *fmt_buf = NULL;
+	int rc;
+	fmt_buf = fsd_expand_printf_ph( fmt );
+	if( fmt_buf )
+		fmt = fmt_buf;
+	rc = vasprintf( &result, fmt, args );
+	if( fmt_buf )
+		fsd_free( fmt_buf );
+	if( rc == -1 )
+		fsd_exc_raise_sys( ENOMEM );
+	return result;
+}
+
+
+/**
+ * ``%m`` placeholder which is a glibc extension
+ * can be safely used in fsd_*printf functions.
+ */
+char *
+fsd_expand_printf_ph( const char *fmt )
+{
+	char* volatile result = NULL;
+
+	if( strstr(fmt, "%m") == NULL )
+		return result;
+
+	TRY
+	 {
+		const char *pos;
+		while( (pos = strstr(fmt, "%m")) != NULL
+				&&  (pos == fmt  ||  pos[-1] != '%') )
+		 {
+			char* volatile errno_msg = NULL;
+			volatile bool own_errno_msg = false;
+			TRY
+			 {
+				char *buf = NULL;
+				size_t fmt_len = strlen(fmt);
+				size_t ph_pos = pos - fmt;
+				size_t errno_msg_len;
+				errno_msg = fsd_astrerror( errno, (bool*)&own_errno_msg );
+				errno_msg_len = strlen(errno_msg);
+				fsd_calloc( buf, fmt_len-2+errno_msg_len+1, char );
+				/* replace ``%m`` with strerror(errno) */
+				strncat( buf, fmt, ph_pos );
+				strcat( buf+ph_pos, errno_msg );
+				strcat( buf+ph_pos+errno_msg_len, fmt+ph_pos+2 );
+				fsd_free( result );
+				fmt = result = buf;
+			 }
+			FINALLY
+			 {
+				if( errno_msg && own_errno_msg )
+					fsd_free( errno_msg );
+			 }
+			END_TRY
+		 }
+	 }
+	EXCEPT_DEFAULT
+	 {
+		fsd_free( result );
+		fsd_exc_reraise();
+	 }
+	END_TRY
+
+	return result;
+}
+
+
+const char *
+fsd_strerror_r( int errnum, char *buffer, size_t buffer_size )
+{
+#	ifdef HAVE_DECL_STRERROR_R
+#		ifdef _GNU_SOURCE
+			return strerror_r( errnum, buffer, buffer_size );
+#		else
+			strerror_r( errnum, buffer, buffer_size );
+			return buffer;
+#		endif /* !_GNU_SOURCE */
+#	else /* assume strerror is thread safe -- returned string is constant */
+		return strerror(errnum);
+#	endif /* ! HAVE_STRERROR_R */
+}
+
+
+char *
+fsd_astrerror( int errnum, bool *malloced )
+{
+#ifdef HAVE_DECL_STRERROR_R
+	char *buffer = NULL;
+	size_t buffer_size = 0;
+	char *result = NULL;
+
+	do {
+		if( buffer_size == 0 )
+			buffer_size = 1024;
+		else
+			buffer_size *= 2;
+		fsd_realloc( buffer, buffer_size, char );
+#		ifdef _GNU_SOURCE
+		result = strerror_r( errnum, buffer, buffer_size );
+		if( result == buffer && strlen(result)+1 == buffer_size )
+			continue;
+#		else
+		if( strerror_r( errnum, buffer, buffer_size ) && errno == ERANGE )
+		 {
+			result = buffer;
+			continue;
+		 }
+#		endif /* !_GNU_SOURCE */
+	} while( false );
+	*malloced = (buffer == result);
+	if( buffer != result )
+		fsd_free( buffer );
+	return result;
+#else /* ! HAVE_DECL_STRERROR_R */
+	/* assume strerror is thread safe -- returned string is constant */
+	*malloced = false;
+	return strerror(errnum);
+#endif /* ! HAVE_DECL_STRERROR_R */
+}
+
+
+void
+fsd_get_time( struct timespec *ts )
+{
+	struct timeval tv;
+	int rc;
+	rc = gettimeofday( &tv, NULL );
+	if( rc )
+		fsd_exc_raise_sys( 0 );
+	else
+	 {
+		ts->tv_sec = tv.tv_sec;
+		ts->tv_nsec = 1000 * tv.tv_usec;
+	 }
+}
+
+
+void
+fsd_ts_add( struct timespec *a, const struct timespec *b )
+{
+	const int nano = 1000000000;
+	a->tv_sec += b->tv_sec;
+	a->tv_nsec += b->tv_nsec;
+	if( a->tv_nsec >= nano )
+	 {
+		a->tv_nsec -= nano;
+		a->tv_sec ++;
+	 }
+}
+
+
+int
+fsd_ts_cmp( const struct timespec *a, const struct timespec *b )
+{
+	if( a->tv_sec != b->tv_sec )
+		return a->tv_sec - b->tv_sec;
+	else
+		return a->tv_nsec - b->tv_nsec;
+}
+
+
+void
+fsd_read_file(
+		const char *filename, bool must_exist,
+		char **content, size_t *length
+		)
+{
+	volatile int fd = -1;
+	char* volatile buffer = NULL;
+	size_t size = 0;
+	size_t capacity = 0;
+	ssize_t n_read;
+
+	TRY
+	 {
+		*content = NULL;
+		*length = 0;
+
+		fd = open( filename, O_RDONLY );
+		if( fd == -1 )
+		 {
+			if( errno==ENOENT && !must_exist )
+			 {
+				*content = NULL;
+				*length = 0;
+			 }
+			else
+				fsd_exc_raise_sys( 0 );
+		 }
+		else
+		 {
+			do {
+				capacity = size + 1024;
+				fsd_realloc( buffer, capacity, char );
+				n_read = read( fd, buffer, capacity-size );
+				if( n_read == (ssize_t)-1 )
+					fsd_exc_raise_sys( 0 );
+				else
+					size += n_read;
+			} while( n_read != 0 );
+
+			fsd_realloc( buffer, size+1, char );
+			buffer[ size ] = '\0';
+		 }
+	 }
+	ELSE
+	 {
+		*content = buffer;  buffer = NULL;
+		*length = size;
+	 }
+	FINALLY
+	 {
+		fsd_free( buffer );
+		if( fd >= 0 )
+			close( fd );
+	 }
+	END_TRY
+}
+
+
+char *
+fsd_getcwd(void)
+{
+	char* volatile buffer = NULL;
+	char* volatile result = NULL;
+	size_t size = 64;
+
+	TRY
+	 {
+		fsd_calloc( buffer, size, char );
+		while( true )
+		 {
+			char *result = getcwd( buffer, size );
+			if( result != NULL )
+				break;
+			else if( errno == ERANGE )
+			 {
+				size *= 2;
+				fsd_realloc( buffer, size, char );
+			 }
+			else
+				fsd_exc_raise_sys( 0 );
+		 }
+		fsd_realloc( buffer, strlen(buffer)+1, char );
+	 }
+	ELSE
+	 { result = buffer;  buffer = NULL; }
+	FINALLY
+	 { fsd_free( buffer ); }
+	END_TRY
+
+	return result;
+}
+
+
+const char *
+fsd_strsignal( int signum )
+{
+#define DETECT_SIG( signame ) \
+	case signame:  return #signame;
+	switch( signum )
+	 {
+		/* signals described by POSIX.1 */
+		DETECT_SIG( SIGHUP  )
+		DETECT_SIG( SIGINT	)
+		DETECT_SIG( SIGQUIT )
+		DETECT_SIG( SIGILL	)
+		DETECT_SIG( SIGABRT )
+		DETECT_SIG( SIGFPE	)
+		DETECT_SIG( SIGKILL )
+		DETECT_SIG( SIGSEGV )
+		DETECT_SIG( SIGPIPE )
+		DETECT_SIG( SIGALRM )
+		DETECT_SIG( SIGTERM )
+		DETECT_SIG( SIGUSR1 )
+		DETECT_SIG( SIGUSR2 )
+		DETECT_SIG( SIGCHLD )
+		DETECT_SIG( SIGCONT )
+		DETECT_SIG( SIGSTOP )
+		DETECT_SIG( SIGTSTP )
+		DETECT_SIG( SIGTTIN )
+		DETECT_SIG( SIGTTOU )
+		/* signals described in SUSv2 and SUSv3 / POSIX 1003.1-2001 */
+#ifdef SIGBUS
+		DETECT_SIG( SIGBUS    )
+#endif
+#ifdef SIGPOLL
+		DETECT_SIG( SIGPOLL	  )
+#endif
+#ifdef SIGPROF
+		DETECT_SIG( SIGPROF	  )
+#endif
+#ifdef SIGSYS
+		DETECT_SIG( SIGSYS	  )
+#endif
+#ifdef SIGTRAP
+		DETECT_SIG( SIGTRAP	  )
+#endif
+#ifdef SIGURG
+		DETECT_SIG( SIGURG	  )
+#endif
+#ifdef SIGVTALRM
+		DETECT_SIG( SIGVTALRM )
+#endif
+#ifdef SIGXCPU
+		DETECT_SIG( SIGXCPU	  )
+#endif
+#ifdef SIGXFSZ
+		DETECT_SIG( SIGXFSZ	  )
+#endif
+		default:
+#		ifdef HAVE_SYS_SIGLIST
+			return sys_siglist[signum];
+#		else
+			return "unknown signal?!";
+#		endif
+			break;
+	 }
+}
+
Index: trunk/drmaa_utils/drmaa_utils/drmaa_attrib.gperf
===================================================================
--- trunk/drmaa_utils/drmaa_utils/drmaa_attrib.gperf	(revision 1)
+++ trunk/drmaa_utils/drmaa_utils/drmaa_attrib.gperf	(revision 1)
@@ -0,0 +1,139 @@
+%{
+/* $Id: drmaa_attrib.gperf 1409 2008-09-25 08:59:45Z lukasz $ */
+/*
+ *  FedStage DRMAA utilities library
+ *  Copyright (C) 2006-2008  FedStage Systems
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+#ifdef HAVE_CONFIG_H
+#	include <config.h>
+#endif
+
+#include <drmaa_utils/common.h>
+#include <drmaa_utils/drmaa_attrib.h>
+#include <drmaa_utils/template.h>
+
+#ifndef lint
+static char rcsid[]
+#	ifdef __GNUC__
+		__attribute__ ((unused))
+#	endif
+	= "$Id: drmaa_attrib.gperf 1409 2008-09-25 08:59:45Z lukasz $";
+#endif
+
+extern const fsd_attribute_t drmaa_attributes[];
+#define t(code) \
+	( & drmaa_attributes[ code ] )
+
+%}
+
+%language=ANSI-C
+%includes
+%readonly-tables
+%pic
+%define lookup-function-name drmaa_attrib_lookup
+%struct-type
+struct drmaa_attrib { int name; const fsd_attribute_t *attr; }
+
+%%
+drmaa_remote_command, t(DRMAA_ATTR_REMOTE_COMMAND)
+drmaa_v_argv, t(DRMAA_ATTR_ARGS)
+drmaa_js_state, t(DRMAA_ATTR_JOB_SUBMISSION_STATE)
+drmaa_v_env, t(DRMAA_ATTR_JOB_ENVIRONMENT)
+drmaa_wd, t(DRMAA_ATTR_WORKING_DIRECTORY)
+drmaa_job_category, t(DRMAA_ATTR_JOB_CATEGORY)
+drmaa_native_specification, t(DRMAA_ATTR_NATIVE_SPECIFICATION)
+drmaa_v_email, t(DRMAA_ATTR_EMAIL)
+drmaa_block_email, t(DRMAA_ATTR_BLOCK_EMAIL)
+drmaa_start_time, t(DRMAA_ATTR_START_TIME)
+drmaa_job_name, t(DRMAA_ATTR_JOB_NAME)
+drmaa_input_path, t(DRMAA_ATTR_INPUT_PATH)
+drmaa_output_path, t(DRMAA_ATTR_OUTPUT_PATH)
+drmaa_error_path, t(DRMAA_ATTR_ERROR_PATH)
+drmaa_join_files, t(DRMAA_ATTR_JOIN_FILES)
+drmaa_transfer_files, t(DRMAA_ATTR_TRANSFER_FILES)
+drmaa_deadline_time, t(DRMAA_ATTR_DEADLINE_TIME)
+drmaa_wct_hlimit, t(DRMAA_ATTR_HARD_WALL_CLOCK_TIME_LIMIT)
+drmaa_wct_slimit, t(DRMAA_ATTR_SOFT_WALL_CLOCK_TIME_LIMIT)
+drmaa_duration_hlimit, t(DRMAA_ATTR_HARD_RUN_DURATION_LIMIT)
+drmaa_duration_slimit, t(DRMAA_ATTR_SOFT_RUN_DURATION_LIMIT)
+%%
+
+#undef t
+
+static const fsd_attribute_t *
+drmaa_template_by_name( const fsd_template_t *self, const char *name )
+{
+	const struct drmaa_attrib *found;
+	found = drmaa_attrib_lookup( name, strlen(name) );
+	if( found != NULL )
+		return found->attr;
+	else
+		fsd_exc_raise_fmt(
+				FSD_ERRNO_INVALID_ARGUMENT,
+				"invalid DRMAA attribute name: %s", name
+				);
+}
+
+
+static const fsd_attribute_t *
+drmaa_template_by_code( const fsd_template_t *self, int code )
+{
+	if( 0 <= code  &&  code < DRMAA_N_ATTRIBUTES )
+		return & drmaa_attributes[ code ];
+	else
+		fsd_exc_raise_fmt(
+				FSD_ERRNO_INVALID_ARGUMENT,
+				"invalid attribute code: %d", code
+				);
+}
+
+
+fsd_template_t *
+drmaa_template_new(void)
+{
+	return fsd_template_new(
+			drmaa_template_by_name,
+			drmaa_template_by_code,
+			DRMAA_N_ATTRIBUTES
+			);
+}
+
+
+const fsd_attribute_t drmaa_attributes[ DRMAA_N_ATTRIBUTES ] = {
+	 { "drmaa_remote_command", DRMAA_ATTR_REMOTE_COMMAND, false },
+	 { "drmaa_v_argv", DRMAA_ATTR_ARGS, true },
+	 { "drmaa_js_state", DRMAA_ATTR_JOB_SUBMISSION_STATE, false },
+	 { "drmaa_v_env", DRMAA_ATTR_JOB_ENVIRONMENT, true },
+	 { "drmaa_wd", DRMAA_ATTR_WORKING_DIRECTORY, false },
+	 { "drmaa_job_category", DRMAA_ATTR_JOB_CATEGORY, false },
+	 { "drmaa_native_specification", DRMAA_ATTR_NATIVE_SPECIFICATION, false },
+	 { "drmaa_v_email", DRMAA_ATTR_EMAIL, true },
+	 { "drmaa_block_email", DRMAA_ATTR_BLOCK_EMAIL, false },
+	 { "drmaa_start_time", DRMAA_ATTR_START_TIME, false },
+	 { "drmaa_job_name", DRMAA_ATTR_JOB_NAME, false },
+	 { "drmaa_input_path", DRMAA_ATTR_INPUT_PATH, false },
+	 { "drmaa_output_path", DRMAA_ATTR_OUTPUT_PATH, false },
+	 { "drmaa_error_path", DRMAA_ATTR_ERROR_PATH, false },
+	 { "drmaa_join_files", DRMAA_ATTR_JOIN_FILES, false },
+	 { "drmaa_transfer_files", DRMAA_ATTR_TRANSFER_FILES, false },
+	 { "drmaa_deadline_time", DRMAA_ATTR_DEADLINE_TIME, false },
+	 { "drmaa_wct_hlimit", DRMAA_ATTR_HARD_WALL_CLOCK_TIME_LIMIT, false },
+	 { "drmaa_wct_slimit", DRMAA_ATTR_SOFT_WALL_CLOCK_TIME_LIMIT, false },
+	 { "drmaa_duration_hlimit", DRMAA_ATTR_HARD_RUN_DURATION_LIMIT, false },
+	 { "drmaa_duration_slimit", DRMAA_ATTR_SOFT_RUN_DURATION_LIMIT, false }
+};
+
+/* vim: set ft=c: */
